/*
 * $Id: biquad2.cpp,v 1.6 2001/07/23 06:47:55 inou Exp $
 * z -> (z^2 + a)^2 + b (a-space for given b)
 */

#include "../plugin.h"

#define RE2IM2   re2=re*re; \
                 im2=im*im;

#define FUNCTION im = 2*re*im + aim; \
                 re = re2-im2 + are; \
		 RE2IM2 \
		 im = 2*re*im + bim; \
                 re = re2-im2 + bre;

#define INCOND  ( (re2+im2)<10 )

#define NAME "Biquad2 (a-space)"
#define CHILD "biquadjulia.so"

const double XL = -2.0;
const double YT = 2.0;
const double XR = 2.0;
const double YB = -2.0;
const double CRE = 0.0;
const double CIM = 1.0;

const int MAXITER = 100;
const int MAXORBIT = 10;
const int PN = 2;
const double PARAM[2] = {0.0, 0.0};

int iter(Point z, double *param, int max)
{
  register double re=0.0;
  register double im=0.0;
  register double are=z.x;
  register double aim=z.y;
  register double bre=param[0];
  register double bim=param[1];
  register double re2=re*re;
  register double im2=im*im;

  register int i;
  for ( i=0; (i<max) && INCOND; i++ ) {
    FUNCTION
    RE2IM2
  }

  int j=i;

  re=param[0]; im=param[1];
  re2=re*re; im2=im*im;

  for ( i=0; (i<max) && INCOND; i++ ) {
    FUNCTION
    RE2IM2
  }

  if ((i>=max) && (j>=max))
    return -1;
  else 
    return ((i<j) ? j*2: i*2+1);
}

Point map(Point z, Point c, double *param)
{
  register double re=z.x;
  register double im=z.y;
  register double are=c.x;
  register double aim=c.y;
  register double bre=*param++;
  register double bim=*param;
  register double re2=re*re;
  register double im2=im*im;

  FUNCTION

  return Point(re,im);
}

Point init(Point c, double *param) {return Point(0,0);}

PluginInfo* getInfo()
{
  PluginInfo* i= new PluginInfo( NAME, XL, YT, XR, YB, MAXITER, MAXORBIT,
				 PN, PARAM, CHILD);
  return i;
}
