/*
 * $Id: quadjulia.cpp,v 1.3 2001/07/23 06:47:56 inou Exp $
 * quadratic maps
 */

#include "../plugin.h"

#define RE2IM2   re2=re*re; \
                 im2=im*im;

#define FUNCTION im = 2*re*im + cim; \
                 re = re2-im2 + cre;

#define INCOND  ( (re2+im2)<10 )

#define NAME "Quadratic Map"
//const char* NAME = "Quadratic Map";
#define CHILD ""
//const char* CHILD="";

const double XL = -2.0;
const double YT = 2.0;
const double XR = 2.0;
const double YB = -2.0;
const double CRE = 0.0;
const double CIM = 1.0;

const int MAXITER = 50;
const int MAXORBIT = 10;
const int PN = 2;
const double PARAM[2] = {0.0, 1.0};

int iter(Point z, double *param, int max)
{
  register double re=z.x;
  register double im=z.y;
  register double cre=*param++;
  register double cim=*param;
  register double re2=re*re;
  register double im2=im*im;

  register int i;
  for ( i=0; (i<max) && INCOND; i++ ) {
    FUNCTION
    RE2IM2
  }

  if (i<max)
    return i;
  else
    return -1;
}

Point map(Point z, Point c, double *param)
{
  register double re=z.x;
  register double im=z.y;
  register double cre=*param++;
  register double cim=*param;
  register double re2=re*re;
  register double im2=im*im;

  FUNCTION

  return Point(re,im);
}

Point init(Point c, double *param) {return c;}

PluginInfo* getInfo()
{
  PluginInfo* i= new PluginInfo(NAME, XL, YT, XR, YB, MAXITER, MAXORBIT,
				PN, PARAM, CHILD);
  return i;
}
