/*
 * $Id: colormap.h,v 1.3 2001/06/15 07:42:54 inou Exp $
 */

#ifndef COLORMAP_H
#define COLORMAP_H

#include <qcolor.h>

const int NUM=256;

class ColorMap
{
public:
  ColorMap();
  ColorMap(int r[NUM], int g[NUM], int b[NUM]);
  ColorMap(int c[NUM][3]);
  ColorMap(QColor c[NUM]);
  ColorMap(const char *filename);
  ColorMap(const ColorMap& c);

  QColor Color(int i) { return color[i]; }

  void open(const char *filename);

private:
  QColor color[NUM];
};

#endif // COLORMAP_H
