/*
 * $Id: setparam.h,v 1.3 2001/07/23 06:49:07 inou Exp $
 */

#include "double.h"

#include <qdialog.h>

class QLineEdit;

class SetParam : public QDialog
{
  Q_OBJECT
public:
  SetParam( Rect r, int n, double *p, int *mi, int *mo,
	    QWidget *parent=0, const char *name=0, WFlags f=0 );
  void accept();

signals:
  void orbitSet();
  void paramSet();
  void setRegion( Rect );

private:
  Rect region;
  int paramnum;
  double *param;
  int *maxiter;
  int *maxorbit;

  QLineEdit *edregion[2][2];
  QLineEdit **edparam;
  QLineEdit *edmaxiter;
  QLineEdit *edmaxorbit;
    
};
